class LiftCasesModel {
  List<LiftCasesDetailModel> records;
  int total;
  int size;
  int current;
  bool searchCount;
  int pages;

  LiftCasesModel(
      {this.records,
      this.total,
      this.size,
      this.current,
      this.searchCount,
      this.pages});

  LiftCasesModel.fromJson(Map<String, dynamic> json) {
    if (json['records'] != null) {
      records = new List<LiftCasesDetailModel>();
      json['records'].forEach((v) {
        records.add(new LiftCasesDetailModel.fromJson(v));
      });
    }
    total = json['total'];
    size = json['size'];
    current = json['current'];
    searchCount = json['searchCount'];
    pages = json['pages'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.records != null) {
      data['records'] = this.records.map((v) => v.toJson()).toList();
    }
    data['total'] = this.total;
    data['size'] = this.size;
    data['current'] = this.current;
    data['searchCount'] = this.searchCount;
    data['pages'] = this.pages;
    return data;
  }
}

class LiftCasesDetailModel {
  int id;
  int isPlatformSpecified;
  int createTime;
  String createBy;
  int updateTime;
  String updateBy;
  String expression;
  String usedMethods;
  String imgs;
  int brandId;
  String sessionId;
  String address;
  String chargerId;
  double travelCost;
  double serviceCost;
  double totalCost;
  int arrivedTime;
  int statuz;
  int acceptStatus;
  int arrivedFlag;
  String arrivedAddress;
  int dataTable;
  String createUserId;
  String beforeRepair;
  String afterRepair;
  String customerServiceId;
  int isInvoice;
  double redEnvelopeDeduction;
  int redEnvelopeId;
  double couponDeduction;
  int couponId;
  int liftCaseAppealStatus;
  double payCost;
  String orderNo;
  int payType;
  String orderSerialNumber;
  String name;
  String avatarUrl;
  String brandName;
  String videoUrl;
  String cancelSeason;
  LiftCaseAppealEntityModel liftCaseAppealEntity;
  QuestionBankEntityModel questionBankEntity;


  LiftCasesDetailModel(
      {this.id,
      this.isPlatformSpecified,
      this.createTime,
      this.createBy,
      this.videoUrl,
      this.updateTime,
      this.updateBy,
      this.expression,
      this.usedMethods,
      this.imgs,
      this.brandId,
      this.sessionId,
      this.address,
      this.chargerId,
      this.travelCost,
      this.serviceCost,
      this.totalCost,
      this.arrivedTime,
      this.statuz,
      this.acceptStatus,
      this.arrivedFlag,
      this.arrivedAddress,
      this.dataTable,
      this.createUserId,
      this.beforeRepair,
      this.afterRepair,
      this.customerServiceId,
      this.isInvoice,
      this.redEnvelopeDeduction,
      this.redEnvelopeId,
      this.couponDeduction,
      this.couponId,
      this.payCost,
      this.orderNo,
      this.payType,
      this.orderSerialNumber,
      this.name,
      this.avatarUrl,
      this.brandName,
      this.cancelSeason,
      this.liftCaseAppealStatus,
      this.liftCaseAppealEntity,
      this.questionBankEntity
  });

  LiftCasesDetailModel.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    isPlatformSpecified = json['isPlatformSpecified'];
    videoUrl = json['videoUrl'];
    liftCaseAppealStatus = json['liftCaseAppealStatus'];
    createTime = json['createTime'];
    createBy = json['createBy'];
    updateTime = json['updateTime'];
    updateBy = json['updateBy'];
    expression = json['expression'];
    usedMethods = json['usedMethods'];
    imgs = json['imgs'];
    brandId = json['brandId'];
    sessionId = json['sessionId'];
    address = json['address'];
    chargerId = json['chargerId'];
    travelCost = json['travelCost'];
    serviceCost = json['serviceCost'];
    totalCost = json['totalCost'];
    arrivedTime = json['arrivedTime'];
    statuz = json['statuz'];
    acceptStatus = json['acceptStatus'];
    arrivedFlag = json['arrivedFlag'];
    arrivedAddress = json['arrivedAddress'];
    dataTable = json['dataTable'];
    createUserId = json['createUserId'];
    beforeRepair = json['beforeRepair'];
    afterRepair = json['afterRepair'];
    customerServiceId = json['customerServiceId'];
    isInvoice = json['isInvoice'];
    redEnvelopeDeduction = json['redEnvelopeDeduction'];
    redEnvelopeId = json['redEnvelopeId'];
    couponDeduction = json['couponDeduction'];
    couponId = json['couponId'];
    payCost = json['payCost'];
    orderNo = json['orderNo'];
    payType = json['payType'];
    orderSerialNumber = json['orderSerialNumber'];
    name = json['name'];
    avatarUrl = json['avatarUrl'];
    brandName = json['brandName'];
    cancelSeason = json['cancelSeason'];
    liftCaseAppealEntity = json['liftCaseAppealEntity'] != null
        ? new LiftCaseAppealEntityModel.fromJson(json['liftCaseAppealEntity'])
        : null;
    questionBankEntity = json['questionBankEntity'] != null
        ? new QuestionBankEntityModel.fromJson(json['questionBankEntity'])
        : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['isPlatformSpecified'] = this.isPlatformSpecified;
    data['liftCaseAppealStatus'] = this.liftCaseAppealStatus;
    data['createTime'] = this.createTime;
    data['createBy'] = this.createBy;
    data['updateTime'] = this.updateTime;
    data['updateBy'] = this.updateBy;
    data['videoUrl'] = this.videoUrl;
    data['expression'] = this.expression;
    data['usedMethods'] = this.usedMethods;
    data['imgs'] = this.imgs;
    data['brandId'] = this.brandId;
    data['sessionId'] = this.sessionId;
    data['address'] = this.address;
    data['chargerId'] = this.chargerId;
    data['travelCost'] = this.travelCost;
    data['serviceCost'] = this.serviceCost;
    data['totalCost'] = this.totalCost;
    data['arrivedTime'] = this.arrivedTime;
    data['statuz'] = this.statuz;
    data['acceptStatus'] = this.acceptStatus;
    data['arrivedFlag'] = this.arrivedFlag;
    data['arrivedAddress'] = this.arrivedAddress;
    data['dataTable'] = this.dataTable;
    data['createUserId'] = this.createUserId;
    data['beforeRepair'] = this.beforeRepair;
    data['afterRepair'] = this.afterRepair;
    data['customerServiceId'] = this.customerServiceId;
    data['isInvoice'] = this.isInvoice;
    data['redEnvelopeDeduction'] = this.redEnvelopeDeduction;
    data['redEnvelopeId'] = this.redEnvelopeId;
    data['couponDeduction'] = this.couponDeduction;
    data['couponId'] = this.couponId;
    data['payCost'] = this.payCost;
    data['orderNo'] = this.orderNo;
    data['payType'] = this.payType;
    data['orderSerialNumber'] = this.orderSerialNumber;
    data['name'] = this.name;
    data['avatarUrl'] = this.avatarUrl;
    data['brandName'] = this.brandName;
    data['cancelSeason'] = this.cancelSeason;
    if (this.liftCaseAppealEntity != null) {
      data['liftCaseAppealEntity'] = this.liftCaseAppealEntity.toJson();
    }
    if (this.questionBankEntity != null) {
      data['questionBankEntity'] = this.questionBankEntity.toJson();
    }
    return data;
  }
}

class QuestionBankEntityModel {
  String notExamineReason;

  QuestionBankEntityModel(
      {this.notExamineReason,});

  QuestionBankEntityModel.fromJson(Map<String, dynamic> json) {
    notExamineReason = json['notExamineReason'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['notExamineReason'] = this.notExamineReason;
    return data;
  }
}


class LiftCaseAppealEntityModel {
  String appealerId;
  String cancelSeason;
  int caseId;
  String content;
  String createBy;
  int createTime;
  int dataId;
  String expertName;
  String expression;
  int id;
  String imgs;
  String sessionid;
  int statuz;
  String updateBy;
  int updateTime;
  String userName;

  LiftCaseAppealEntityModel(
      {this.appealerId,
      this.cancelSeason,
      this.caseId,
      this.content,
      this.createBy,
      this.createTime,
      this.dataId,
      this.expertName,
      this.expression,
      this.id,
      this.imgs,
      this.sessionid,
      this.statuz,
      this.updateBy,
      this.updateTime,
      this.userName});

  LiftCaseAppealEntityModel.fromJson(Map<String, dynamic> json) {
    appealerId = json['appealerId'];
    cancelSeason = json['cancelSeason'];
    caseId = json['caseId'];
    content = json['content'];
    createBy = json['createBy'];
    createTime = json['createTime'];
    dataId = json['dataId'];
    expertName = json['expertName'];
    expression = json['expression'];
    id = json['id'];
    imgs = json['imgs'];
    sessionid = json['sessionid'];
    statuz = json['statuz'];
    updateBy = json['updateBy'];
    updateTime = json['updateTime'];
    userName = json['userName'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['appealerId'] = this.appealerId;
    data['cancelSeason'] = this.cancelSeason;
    data['caseId'] = this.caseId;
    data['content'] = this.content;
    data['createBy'] = this.createBy;
    data['createTime'] = this.createTime;
    data['dataId'] = this.dataId;
    data['expertName'] = this.expertName;
    data['expression'] = this.expression;
    data['id'] = this.id;
    data['imgs'] = this.imgs;
    data['sessionid'] = this.sessionid;
    data['statuz'] = this.statuz;
    data['updateBy'] = this.updateBy;
    data['updateTime'] = this.updateTime;
    data['userName'] = this.userName;
    return data;
  }
}
