import 'package:liftmanager/internal/bbs/page/tab/position/position_list.dart';
import 'package:liftmanager/mvp/base_page_presenter.dart';
import 'package:liftmanager/net/api_service.dart';
import 'package:liftmanager/widgets/state_layout.dart';

class PositionListPresenterSeconds
    extends BasePagePresenter<PositionListState> {
  Future getPositionList(
    int page, {
    String provinceName,
    String cityName,
    int minSalary,
    int maxSalary,
    String job,
  }) async {
    await NewApiService().getPositionList(page, 20,
        provinceName: provinceName,
        cityName: cityName,
        minSalary: minSalary,
        maxSalary: maxSalary,
        job: job, onSuccess: (res) {
      view.closeProgress();
      if (res != null) {
        view.provider.setHasMore(res.records.length == 20);
        if (page == 1) {
          view.provider.list.clear();
          if (res.records.isEmpty) {
            view.provider.setStateType(StateType.empty);
          } else {
            view.provider.addAll(res.records);
          }
        } else {
          view.provider.addAll(res.records);
        }
      } else {
        /// 加载失败
        view.provider.setHasMore(false);
        view.provider.setStateType(StateType.empty);
      }
    }, onError: (code, msg) {
      view.closeProgress();
      view.provider.setHasMore(false);
      view.provider.setStateType(StateType.network);
    });
  }
}
