class HeavyItem {
  String projectName;
  int projectUsage;
  String address;
  int actualNum;
  String province;
  String city;
  String district;
  String startDate;
  String endDate;
  String companyName;
  String companyContact;
  String telephone;
  String areaDirector;
  String areaName;
  String regionId;
  String clerkName;
  String isMonitor;

  HeavyItem({
    this.projectName = "",
    this.projectUsage = 0,
    this.address = "",
    this.actualNum = 0,
    this.province = "",
    this.city = "",
    this.district = "",
    this.startDate = "",
    this.endDate = "",
    this.companyName = "",
    this.companyContact = "",
    this.telephone = "",
    this.areaDirector = "",
    this.areaName = "",
    this.regionId = "",
    this.clerkName = "",
    this.isMonitor = ""
  });

  HeavyItem.fromJsonMap(Map<String, dynamic> map)
      : projectName = map["projectName"],
        projectUsage = map["projectUsage"],
        address = map["address"],
        actualNum = map["actualNum"] ?? 0,
        province = map["province"],
        city = map["city"],
        district = map["district"],
        startDate = map["startDate"],
        endDate = map["endDate"],
        companyName = map["companyName"],
        companyContact = map["companyContact"],
        telephone = map["telephone"],
        areaDirector = map["areaDirector"],
        areaName = map["areaName"],
        regionId = map["regionId"],
        clerkName = map["clerkName"] ?? "",
        isMonitor = map["isMonitor"] ?? "";

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['projectName'] = projectName;
    data['projectUsage'] = projectUsage;
    data['address'] = address;
    data['actualNum'] = actualNum;
    data['province'] = province;
    data['city'] = city;
    data['district'] = district;
    data['startDate'] = startDate;
    data['endDate'] = endDate;
    data['companyName'] = companyName;
    data['companyContact'] = companyContact;
    data['telephone'] = telephone;
    data['areaDirector'] = areaDirector;
    data['areaName'] = areaName;
    data['regionId'] = regionId;
    data['clerkName'] = clerkName;
    data['isMonitor'] = isMonitor;
    return data;
  }
}
